<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDistanceReportItem_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfDistanceReportItem_V3 extends AbstractStructArrayBase
{
    /**
     * The DistanceReportItem_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DistanceReportItem_V3[]
     */
    public $DistanceReportItem_V3;
    /**
     * Constructor method for ArrayOfDistanceReportItem_V3
     * @uses ArrayOfDistanceReportItem_V3::setDistanceReportItem_V3()
     * @param \StructType\DistanceReportItem_V3[] $distanceReportItem_V3
     */
    public function __construct(array $distanceReportItem_V3 = array())
    {
        $this
            ->setDistanceReportItem_V3($distanceReportItem_V3);
    }
    /**
     * Get DistanceReportItem_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DistanceReportItem_V3[]|null
     */
    public function getDistanceReportItem_V3()
    {
        return isset($this->DistanceReportItem_V3) ? $this->DistanceReportItem_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDistanceReportItem_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDistanceReportItem_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDistanceReportItem_V3ForArrayConstraintsFromSetDistanceReportItem_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDistanceReportItem_V3DistanceReportItem_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfDistanceReportItem_V3DistanceReportItem_V3Item instanceof \StructType\DistanceReportItem_V3) {
                $invalidValues[] = is_object($arrayOfDistanceReportItem_V3DistanceReportItem_V3Item) ? get_class($arrayOfDistanceReportItem_V3DistanceReportItem_V3Item) : sprintf('%s(%s)', gettype($arrayOfDistanceReportItem_V3DistanceReportItem_V3Item), var_export($arrayOfDistanceReportItem_V3DistanceReportItem_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DistanceReportItem_V3 property can only contain items of type \StructType\DistanceReportItem_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DistanceReportItem_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DistanceReportItem_V3[] $distanceReportItem_V3
     * @return \ArrayType\ArrayOfDistanceReportItem_V3
     */
    public function setDistanceReportItem_V3(array $distanceReportItem_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($distanceReportItem_V3ArrayErrorMessage = self::validateDistanceReportItem_V3ForArrayConstraintsFromSetDistanceReportItem_V3($distanceReportItem_V3))) {
            throw new \InvalidArgumentException($distanceReportItem_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($distanceReportItem_V3) || (is_array($distanceReportItem_V3) && empty($distanceReportItem_V3))) {
            unset($this->DistanceReportItem_V3);
        } else {
            $this->DistanceReportItem_V3 = $distanceReportItem_V3;
        }
        return $this;
    }
    /**
     * Add item to DistanceReportItem_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\DistanceReportItem_V3 $item
     * @return \ArrayType\ArrayOfDistanceReportItem_V3
     */
    public function addToDistanceReportItem_V3(\StructType\DistanceReportItem_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DistanceReportItem_V3) {
            throw new \InvalidArgumentException(sprintf('The DistanceReportItem_V3 property can only contain items of type \StructType\DistanceReportItem_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DistanceReportItem_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DistanceReportItem_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DistanceReportItem_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DistanceReportItem_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DistanceReportItem_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DistanceReportItem_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DistanceReportItem_V3
     */
    public function getAttributeName()
    {
        return 'DistanceReportItem_V3';
    }
}
